#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './ctags2_widgetbase.ui'
**
** Created: Thu Dec 18 13:59:01 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "ctags2_widgetbase.h"

#include <qvariant.h>
#include <qheader.h>
#include <klistview.h>
#include <qlabel.h>
#include <klineedit.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "klistview.h"
#include "klineedit.h"

/*
 *  Constructs a CTags2WidgetBase as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
CTags2WidgetBase::CTags2WidgetBase( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "CTags2WidgetBase" );
    CTags2WidgetBaseLayout = new QVBoxLayout( this, 2, 6, "CTags2WidgetBaseLayout"); 

    output_view = new KListView( this, "output_view" );
    output_view->addColumn( tr2i18n( "Tag" ) );
    output_view->addColumn( tr2i18n( "Type" ) );
    output_view->addColumn( tr2i18n( "File" ) );
    output_view->setAllColumnsShowFocus( TRUE );
    output_view->setResizeMode( KListView::AllColumns );
    CTags2WidgetBaseLayout->addWidget( output_view );

    layout3 = new QHBoxLayout( 0, 0, 6, "layout3"); 

    textLabel1 = new QLabel( this, "textLabel1" );
    layout3->addWidget( textLabel1 );

    input_edit = new KLineEdit( this, "input_edit" );
    layout3->addWidget( input_edit );

    hitcount_label = new QLabel( this, "hitcount_label" );
    layout3->addWidget( hitcount_label );
    spacer1 = new QSpacerItem( 80, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout3->addItem( spacer1 );

    datetime_label = new QLabel( this, "datetime_label" );
    layout3->addWidget( datetime_label );

    generate_button = new QPushButton( this, "generate_button" );
    generate_button->setFocusPolicy( QPushButton::NoFocus );
    layout3->addWidget( generate_button );
    CTags2WidgetBaseLayout->addLayout( layout3 );
    languageChange();
    resize( QSize(780, 397).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( input_edit, SIGNAL( returnPressed() ), this, SLOT( line_edit_changed() ) );
    connect( input_edit, SIGNAL( textChanged(const QString&) ), this, SLOT( line_edit_changed_delayed() ) );
    connect( generate_button, SIGNAL( clicked() ), this, SLOT( regeneratebutton_clicked() ) );

    // tab order
    setTabOrder( input_edit, output_view );
}

/*
 *  Destroys the object and frees any allocated resources
 */
CTags2WidgetBase::~CTags2WidgetBase()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void CTags2WidgetBase::languageChange()
{
    setCaption( QString::null );
    output_view->header()->setLabel( 0, tr2i18n( "Tag" ) );
    output_view->header()->setLabel( 1, tr2i18n( "Type" ) );
    output_view->header()->setLabel( 2, tr2i18n( "File" ) );
    QWhatsThis::add( output_view, tr2i18n( "Result view for a tag lookup. Click a line to go to the corresponding place in the code." ) );
    textLabel1->setText( tr2i18n( "Lookup:" ) );
    QWhatsThis::add( input_edit, tr2i18n( "Type the identifier you want to lookup. <p> The identifier will populate and display a reducing list as you type." ) );
    hitcount_label->setText( tr2i18n( "Hits:" ) );
    datetime_label->setText( tr2i18n( "Date:" ) );
    generate_button->setText( tr2i18n( "Regenerate" ) );
    QWhatsThis::add( generate_button, tr2i18n( "Press to regenerate CTags database.<p>This will take some time on a large project." ) );
}

void CTags2WidgetBase::line_edit_changed_delayed()
{
    qWarning( "CTags2WidgetBase::line_edit_changed_delayed(): Not implemented yet" );
}

void CTags2WidgetBase::line_edit_changed()
{
    qWarning( "CTags2WidgetBase::line_edit_changed(): Not implemented yet" );
}

void CTags2WidgetBase::regeneratebutton_clicked()
{
    qWarning( "CTags2WidgetBase::regeneratebutton_clicked(): Not implemented yet" );
}

#include "ctags2_widgetbase.moc"
